require "contact_congress_parser/version"

require 'yaml'
require 'uri'

require 'contact_congress_parser/parser'
require 'contact_congress_parser/form'
require 'contact_congress_parser/action'
require 'contact_congress_parser/field'
require 'contact_congress_parser/success_conditions'


module ContactCongressParser
  def self.parse_form(yaml_str)
    Parser.new(yaml_str).form
  end

  def self.parse_bioguide(yaml_str)
    Parser.new(yaml_str).bioguide
  end

  def self.parse_all_to_constant(path_to_dir)
    "Forms = Hash.new\n" +
    Dir.glob("#{path_to_dir}/*.yaml").map do |file|
      yaml_str = File.read(file)
      bioguide = self.parse_bioguide(yaml_str)
      form = self.parse_form(yaml_str)
      "Forms[\"#{bioguide}\"] = #{form}"
    end.join("\n")
  end
end
