module ContactCongressParser
  class Form
    def initialize(data)
      @data = data
    end

    def to_s
      create_form do
        actions.map { |action| tab + action.to_s }.join(newline) +
        newline +
        success_conditions.to_s
      end
    end

  private
    def create_form(&block)
      "Conformity::Form.new('#{base_url}') do\n" +
      yield +
      'end'
    end

    def base_url
      @base_url ||= URI.join(steps.first['visit'], "/")
    end

    def actions
      @actions ||= steps.map { |step| Action.create_from_step(step) }.flatten
    end

    def success_conditions
      @success_conditions ||= SuccessConditions.new(success_data)
    end

    def steps
      @steps ||= @data['contact_form']['steps']
    end

    def success_data
      @success ||= @data['contact_form']['success']
    end

    def newline
      "\n"
    end

    def tab
      '  '
    end
  end
end
