module ContactCongressParser
  class SuccessConditions
    def initialize(data)
      @data = data
    end

    def to_s
      (has_content_str     ? '  ' + has_content_str + "\n" : '') +
      (has_status_code_str ? '  ' + has_status_code_str + "\n" : '')
    end

  private
    attr_reader :data

    def has_content_str
      "has_content? \"#{content}\"" if content
    end

    def has_status_code_str
      "has_status_code? #{status_code}" if status_code
    end

    def content
      data.fetch('body', {}).fetch('contains', nil)
    end

    def status_code
      data.fetch('headers', {}).fetch('status', nil)
    end
  end
end
